<?php

namespace Drupal\fluent;

use Drupal\Core\Field\FieldItemInterface;
use Drupal\fluent\Plugin\FluentFieldItemResolverPluginManager;
use Illuminate\Support\Collection as BaseCollection;

class FieldItemResolver
{

  /**
   * @var \Drupal\fluent\Plugin\FluentFieldItemResolverPluginManager
   */
  private FluentFieldItemResolverPluginManager $pluginManager;

  private array $fieldResolvers = [];

  public function __construct(FluentFieldItemResolverPluginManager $plugin) {
    $this->pluginManager = $plugin;

    foreach ($this->pluginManager->getDefinitions() as $id => $definition) {
      $this->fieldResolvers[$id] = $this->pluginManager->createInstance($id);
    }
  }

  public function resolve($field, array $path) {
    // TODO: Create plugin for each @FieldType
    if ($field instanceof FieldItemInterface) {
      $field = $field->getString();
    }

    return $field;
  }

  private function findPlugin($field) {
    foreach ($this->fieldResolvers as $resolver) {
      if ($resolver->can($field)) {
        return $resolver->handler();
      }
    }
  }

}
