<?php

namespace Drupal\fluent\Plugin\FluentFieldResolver;

use Drupal\Core\Field\EntityReferenceFieldItemListInterface;
use Drupal\Core\Field\FieldDefinitionInterface;
use Drupal\Core\Field\Plugin\Field\FieldType\EntityReferenceItem;
use Drupal\fluent\Plugin\FluentFieldResolverBase;

/**
 * @FluentFieldResolver(
 *   id = "entity_reference",
 *   label = "Entity Reference Resolver",
 *   weight = 90
 * )
 */
class ContentEntityReference extends EntityReferenceBase {

  public function handler($object, $fieldName, array $options = []) {
    if ($object instanceof EntityReferenceFieldItemListInterface) {
      return $this->resolveList($object, $options);
    }

    if ($object instanceof EntityReferenceItem) {
      return $this->loadEntityUsingFieldDefinition($object);
    }

    if ($object->hasField($fieldName)) {
      return $object->{$fieldName};
    }
  }

  /**
   *
   */
  public function can(FieldDefinitionInterface $fieldDefinition): bool {
    $types = [
      'entity_reference',
      'image',
    ];

    return in_array($fieldDefinition->getType(), $types);
  }

}
