<?php

namespace Drupal\fluent\Plugin\FluentFieldResolver;

use Drupal\Core\Field\EntityReferenceFieldItemList;
use Drupal\fluent\Plugin\FluentFieldResolverBase;

abstract class EntityReferenceBase extends FluentFieldResolverBase
{

  public function resolveList($object, $options) {
    $position = $options['position'];

    if ($position === -1) {
      return $object->referencedEntities();
    }

    // TODO: validate cardinality of field storage definition.
    if ($object->count() > $position) {
      return $object->get($position);
    } else {
      return \Drupal::entityTypeManager()
        ->getStorage($object->getFieldDefinition()->getSetting('target_type'))
        ->load($object->getFieldDefinition()->getDefaultValue($object->getEntity())[0]['target_id']);

    }

    // TODO: throw exception.
  }

  public function loadEntityUsingFieldDefinition($object) {
    $entityType = $object->getFieldDefinition()->getSetting('target_type');

    return \Drupal::entityTypeManager()
      ->getStorage($entityType)
      ->load($object->target_id);
  }
}
