<?php

namespace Drupal\fluent\Plugin\FluentFieldResolver;

use Drupal\Core\Field\FieldDefinitionInterface;
use Drupal\entity_reference_revisions\EntityReferenceRevisionsFieldItemList;
use Drupal\entity_reference_revisions\Plugin\Field\FieldType\EntityReferenceRevisionsItem;

/**
 * @FluentFieldResolver(
 *   id = "entity_reference_revision",
 *   label = "Entity Reference Revision Resolver",
 *   weight = 90
 * )
 */
class EntityReferenceRevision extends EntityReferenceBase
{

  public function handler($object, $fieldName, array $options = [])
  {

    if ($object instanceof EntityReferenceRevisionsFieldItemList) {
      return $this->resolveList($object, $options);
    }

    if ($object instanceof EntityReferenceRevisionsItem) {
      return $this->loadEntityUsingFieldDefinition($object);
    }

    if ($object->hasField($fieldName)) {
      return $object->{$fieldName};
    }
  }

  public function can(FieldDefinitionInterface $fieldDefinition): bool
  {
    return $fieldDefinition->getType() === 'entity_reference_revisions';
  }

}
