<?php

namespace Drupal\fluent\Plugin;

use Drupal\Component\Plugin\PluginInspectionInterface;
use Drupal\Core\Field\FieldDefinitionInterface;

/**
 * Defines an interface for Fluent field resolver plugins.
 */
interface FluentFieldResolverInterface extends PluginInspectionInterface {

  /**
   * @param $object
   * @param $fieldName
   * @param array $options
   *
   * @return mixed
   */
  public function handler($object, $fieldName, array $options = []);

  /**
   * @param \Drupal\Core\Field\FieldDefinitionInterface $fieldDefinition
   *
   * @return bool
   */
  public function can(FieldDefinitionInterface $fieldDefinition): bool;

}
